<template>
  <div ref="chartRef" :class="className" :style="{ height: height, width: width }" />
</template>

<script setup>
import { faHandsAmericanSignLanguageInterpreting } from '@fortawesome/free-solid-svg-icons';
import * as echarts from 'echarts'
import { inject } from 'vue'
let chart = null

const { proxy } = getCurrentInstance()
const animationDuration = 2000
const data = inject('DailyStatistics')
const props = defineProps({
  className: {
    type: String,
    default: 'chart',
  },
  width: {
    type: String,
    default: '100%',
  },
  height: {
    type: String,
    default: '300px',
  },
})
function initChart() {
  chart = echarts.init(proxy.$refs.chartRef, 'macarons')

  chart.setOption({
    tooltip: {
      trigger: 'axis',
      axisPointer: {
        // 坐标轴指示器，坐标轴触发有效
        type: 'shadow', // 默认为直线，可选为：'line' | 'shadow'
      },
    },
    grid: {
      top: 10,
      left: '2%',
      right: '2%',
      bottom: '3%',
      containLabel: true,
    },
    xAxis: [
      {
        type: 'category',
        data: ['质检', '入库', '出库', '装配'],
        axisTick: {
          alignWithLabel: true,
        },
      },
    ],
    yAxis: [
      {
        type: 'value',
        axisTick: {
          show: false,
        },
      },
    ],
    series: [
      {
        name: '关键件',
        type: 'bar',
        data: [data.qa_key, data.in_key, data.out_key, data.ass_key],
        animationDuration,
      },
      {
        name: '非关键件',
        type: 'bar',
        data: [data.qa, data.in, data.out, data.ass],
        animationDuration,
      },
    ],
  })
}

function setOptions(data) {
  chart.setOption({
    series: [
      {
        name: '关键件',
        type: 'bar',
        data: [data.qa_key, data.in_key, data.out_key, data.ass_key],
        animationDuration,
      },
      {
        name: '非关键件',
        type: 'bar',
        data: [data.qa, data.in, data.out, data.ass],
        animationDuration,
      },
    ],
  })
}
onMounted(() => {
  initChart()
})
window.onresize = function () {
  chart.resize()
}
watch(data, (newData, oldData) => {
  setOptions(newData)
}
)
</script>
